const Tool = require('../src/cli').run('--build-test')

const obj = [
  {
    _links: {
      events: 'https://gitlab.com/api/v4/projects/15184620/events',
      issues: 'https://gitlab.com/api/v4/projects/15184620/issues',
      labels: 'https://gitlab.com/api/v4/projects/15184620/labels',
      members: 'https://gitlab.com/api/v4/projects/15184620/members',
      merge_requests:
        'https://gitlab.com/api/v4/projects/15184620/merge_requests',
      repo_branches:
        'https://gitlab.com/api/v4/projects/15184620/repository/branches',
      self: 'https://gitlab.com/api/v4/projects/15184620'
    },
    approvals_before_merge: 0,
    archived: false,
    auto_cancel_pending_pipelines: 'enabled',
    auto_devops_deploy_strategy: 'continuous',
    auto_devops_enabled: false,
    autoclose_referenced_issues: true,
    avatar_url: null,
    build_coverage_regex: null,
    build_timeout: 3600,
    builds_access_level: 'enabled',
    can_create_merge_request_in: false,
    ci_config_path: null,
    ci_default_git_depth: 50,
    container_registry_enabled: true,
    created_at: '2019-11-05T12:07:49.820Z',
    creator_id: 4911748,
    default_branch: 'master',
    description: '',
    emails_disabled: false,
    empty_repo: false,
    external_authorization_classification_label: '',
    forks_count: 0,
    http_url_to_repo:
      'https://gitlab.com/hapibot-studio-public/starter-kit/starter-kits/create-expressjs.git',
    id: 15184620,
    import_status: 'none',
    issues_access_level: 'enabled',
    issues_enabled: true,
    jobs_enabled: true,
    last_activity_at: '2019-12-05T11:29:27.603Z',
    lfs_enabled: true,
    marked_for_deletion_at: null,
    merge_method: 'merge',
    merge_requests_access_level: 'enabled',
    merge_requests_enabled: true,
    mirror: false,
    name: 'create-expressjs',
    name_with_namespace:
      'Hapibot Studio / Starter Kit / Starter Kit Templates / create-expressjs',
    namespace: {
      avatar_url: null,
      full_path: 'hapibot-studio-public/starter-kit/starter-kits',
      id: 6454448,
      kind: 'group',
      name: 'Starter Kit Templates',
      parent_id: 7155639,
      path: 'starter-kits',
      web_url:
        'https://gitlab.com/groups/hapibot-studio-public/starter-kit/starter-kits'
    },
    only_allow_merge_if_all_discussions_are_resolved: false,
    only_allow_merge_if_pipeline_succeeds: false,
    open_issues_count: 0,
    packages_enabled: true,
    pages_access_level: 'enabled',
    path: 'create-expressjs',
    path_with_namespace:
      'hapibot-studio-public/starter-kit/starter-kits/create-expressjs',
    printing_merge_request_link_enabled: true,
    public_jobs: true,
    readme_url: null,
    remove_source_branch_after_merge: true,
    repository_access_level: 'enabled',
    request_access_enabled: true,
    resolve_outdated_diff_discussions: false,
    service_desk_address:
      'incoming+hapibot-studio-public-starter-kit-starter-kits-create-expressjs-15184620-issue-@incoming.gitlab.com',
    service_desk_enabled: true,
    shared_runners_enabled: true,
    shared_with_groups: [],
    snippets_access_level: 'enabled',
    snippets_enabled: true,
    ssh_url_to_repo:
      'git@gitlab.com:hapibot-studio-public/starter-kit/starter-kits/create-expressjs.git',
    star_count: 0,
    suggestion_commit_message: null,
    tag_list: [],
    visibility: 'public',
    web_url:
      'https://gitlab.com/hapibot-studio-public/starter-kit/starter-kits/create-expressjs',
    wiki_access_level: 'enabled',
    wiki_enabled: true
  },
  {
    _links: {
      events: 'https://gitlab.com/api/v4/projects/15184213/events',
      issues: 'https://gitlab.com/api/v4/projects/15184213/issues',
      labels: 'https://gitlab.com/api/v4/projects/15184213/labels',
      members: 'https://gitlab.com/api/v4/projects/15184213/members',
      merge_requests:
        'https://gitlab.com/api/v4/projects/15184213/merge_requests',
      repo_branches:
        'https://gitlab.com/api/v4/projects/15184213/repository/branches',
      self: 'https://gitlab.com/api/v4/projects/15184213'
    },
    approvals_before_merge: 0,
    archived: false,
    auto_cancel_pending_pipelines: 'enabled',
    auto_devops_deploy_strategy: 'continuous',
    auto_devops_enabled: false,
    autoclose_referenced_issues: true,
    avatar_url: null,
    build_coverage_regex: null,
    build_timeout: 3600,
    builds_access_level: 'enabled',
    can_create_merge_request_in: false,
    ci_config_path: null,
    ci_default_git_depth: 50,
    container_registry_enabled: true,
    created_at: '2019-11-05T11:43:02.982Z',
    creator_id: 4911748,
    default_branch: 'master',
    description: 'Create React App starter kit',
    emails_disabled: false,
    empty_repo: false,
    external_authorization_classification_label: '',
    forks_count: 0,
    http_url_to_repo:
      'https://gitlab.com/hapibot-studio-public/starter-kit/starter-kits/create-react-app.git',
    id: 15184213,
    import_status: 'none',
    issues_access_level: 'enabled',
    issues_enabled: true,
    jobs_enabled: true,
    last_activity_at: '2019-12-05T12:03:25.535Z',
    lfs_enabled: true,
    marked_for_deletion_at: null,
    merge_method: 'merge',
    merge_requests_access_level: 'enabled',
    merge_requests_enabled: true,
    mirror: false,
    name: 'create-react-app',
    name_with_namespace:
      'Hapibot Studio / Starter Kit / Starter Kit Templates / create-react-app',
    namespace: {
      avatar_url: null,
      full_path: 'hapibot-studio-public/starter-kit/starter-kits',
      id: 6454448,
      kind: 'group',
      name: 'Starter Kit Templates',
      parent_id: 7155639,
      path: 'starter-kits',
      web_url:
        'https://gitlab.com/groups/hapibot-studio-public/starter-kit/starter-kits'
    },
    only_allow_merge_if_all_discussions_are_resolved: false,
    only_allow_merge_if_pipeline_succeeds: false,
    open_issues_count: 0,
    packages_enabled: true,
    pages_access_level: 'enabled',
    path: 'create-react-app',
    path_with_namespace:
      'hapibot-studio-public/starter-kit/starter-kits/create-react-app',
    printing_merge_request_link_enabled: true,
    public_jobs: true,
    readme_url:
      'https://gitlab.com/hapibot-studio-public/starter-kit/starter-kits/create-react-app/-/blob/master/README.md',
    remove_source_branch_after_merge: true,
    repository_access_level: 'enabled',
    request_access_enabled: true,
    resolve_outdated_diff_discussions: false,
    service_desk_address:
      'incoming+hapibot-studio-public-starter-kit-starter-kits-create-react-app-15184213-issue-@incoming.gitlab.com',
    service_desk_enabled: true,
    shared_runners_enabled: true,
    shared_with_groups: [],
    snippets_access_level: 'enabled',
    snippets_enabled: true,
    ssh_url_to_repo:
      'git@gitlab.com:hapibot-studio-public/starter-kit/starter-kits/create-react-app.git',
    star_count: 0,
    suggestion_commit_message: null,
    tag_list: [],
    visibility: 'public',
    web_url:
      'https://gitlab.com/hapibot-studio-public/starter-kit/starter-kits/create-react-app',
    wiki_access_level: 'enabled',
    wiki_enabled: true
  },
  {
    _links: {
      events: 'https://gitlab.com/api/v4/projects/15184154/events',
      issues: 'https://gitlab.com/api/v4/projects/15184154/issues',
      labels: 'https://gitlab.com/api/v4/projects/15184154/labels',
      members: 'https://gitlab.com/api/v4/projects/15184154/members',
      merge_requests:
        'https://gitlab.com/api/v4/projects/15184154/merge_requests',
      repo_branches:
        'https://gitlab.com/api/v4/projects/15184154/repository/branches',
      self: 'https://gitlab.com/api/v4/projects/15184154'
    },
    approvals_before_merge: 0,
    archived: false,
    auto_cancel_pending_pipelines: 'enabled',
    auto_devops_deploy_strategy: 'continuous',
    auto_devops_enabled: false,
    autoclose_referenced_issues: true,
    avatar_url: null,
    build_coverage_regex: null,
    build_timeout: 3600,
    builds_access_level: 'enabled',
    can_create_merge_request_in: false,
    ci_config_path: null,
    ci_default_git_depth: 50,
    container_registry_enabled: true,
    created_at: '2019-11-05T11:39:00.217Z',
    creator_id: 4911748,
    default_branch: 'master',
    description: 'React Native starter kit ',
    emails_disabled: false,
    empty_repo: false,
    external_authorization_classification_label: '',
    forks_count: 0,
    http_url_to_repo:
      'https://gitlab.com/hapibot-studio-public/starter-kit/starter-kits/react-native.git',
    id: 15184154,
    import_status: 'none',
    issues_access_level: 'enabled',
    issues_enabled: true,
    jobs_enabled: true,
    last_activity_at: '2019-12-03T10:54:02.718Z',
    lfs_enabled: true,
    marked_for_deletion_at: null,
    merge_method: 'merge',
    merge_requests_access_level: 'enabled',
    merge_requests_enabled: true,
    mirror: false,
    name: 'react-native',
    name_with_namespace:
      'Hapibot Studio / Starter Kit / Starter Kit Templates / react-native',
    namespace: {
      avatar_url: null,
      full_path: 'hapibot-studio-public/starter-kit/starter-kits',
      id: 6454448,
      kind: 'group',
      name: 'Starter Kit Templates',
      parent_id: 7155639,
      path: 'starter-kits',
      web_url:
        'https://gitlab.com/groups/hapibot-studio-public/starter-kit/starter-kits'
    },
    only_allow_merge_if_all_discussions_are_resolved: false,
    only_allow_merge_if_pipeline_succeeds: false,
    open_issues_count: 0,
    packages_enabled: true,
    pages_access_level: 'enabled',
    path: 'react-native',
    path_with_namespace:
      'hapibot-studio-public/starter-kit/starter-kits/react-native',
    printing_merge_request_link_enabled: true,
    public_jobs: true,
    readme_url: null,
    remove_source_branch_after_merge: true,
    repository_access_level: 'enabled',
    request_access_enabled: true,
    resolve_outdated_diff_discussions: false,
    service_desk_address:
      'incoming+hapibot-studio-public-starter-kit-starter-kits-react-native-15184154-issue-@incoming.gitlab.com',
    service_desk_enabled: true,
    shared_runners_enabled: true,
    shared_with_groups: [],
    snippets_access_level: 'enabled',
    snippets_enabled: true,
    ssh_url_to_repo:
      'git@gitlab.com:hapibot-studio-public/starter-kit/starter-kits/react-native.git',
    star_count: 0,
    suggestion_commit_message: null,
    tag_list: [],
    visibility: 'public',
    web_url:
      'https://gitlab.com/hapibot-studio-public/starter-kit/starter-kits/react-native',
    wiki_access_level: 'enabled',
    wiki_enabled: true
  }
]

test('gitlab api', async () => {
  const output = await Tool.then(toolbox =>
    toolbox.api.get('https://gitlab.com/api/v4/groups/6454448/projects', '')
  )
  expect(output).toEqual(obj)
})
